function handleFileUrl(ownerID,fileType, paths) {
    var result = [];
    if (paths) {
        $.each(paths, function(index, value) {
            result.push(value);    //seeModuleOrFunctionFile为后台请求图片的方法
        });
    }
    return result;
}
//使用命名空间。
(function(window) {

    // 如果需要在模态框中使用webuploader，那么必须先调用prepareModal，
    // 再调用initWebUploader。这样可以解决模态框中使用webuploader出现的BUG。
    // 例如prepareModal('#addProductModal')
    this.prepareModal = function(modalId) {
        var _$modal = $(modalId);
        _$modal.css('display', 'block');
        _$modal.addClass("webuploader-element-invisible");
        _$modal.on('show.bs.modal', function() {
            _$modal.removeClass("webuploader-element-invisible");
        });
    }

    // 返回一个webuploader实例。
    // 例如initWebUploader('#uploader', '#filePicker', '#filePicker2', 'uploadMethod')   
    this.initWebUploader = function(webUploaderId, filePickerId, fileAddId, uploadUrl,wuploader) {  //前三个参数对应的是jsp页面的div的id，最后一个参数，是后台调用的上传方法名字
    	
        var $ = jQuery, // just in case. Make sure it's not an other library.

            $wrap = $(webUploaderId),

            // 图片容器
            $queue = $('<ul class="filelist"></ul>')
                .appendTo($wrap.find('.queueList')),

            // 状态栏，包括进度和控制按钮
            $statusBar = $wrap.find('.statusBar'),

            // 文件总体选择信息。
            $info = $statusBar.find('.info'),

            // 上传按钮
            $upload = $wrap.find('.uploadBtn'),

            // 没选择文件之前的内容。
            $placeHolder = $wrap.find('.placeholder'),

            // 总体进度条
            $progress = $statusBar.find('.progress').hide(),

            // 添加的文件数量
            fileCount = 0,

            // 添加的文件总大小
            fileSize = 0,

            // 优化retina, 在retina下这个值是2
            ratio = window.devicePixelRatio || 1,

            // 缩略图大小
            //        thumbnailWidth = 110 * ratio,
            //        thumbnailHeight = 110 * ratio,
            thumbnailWidth = ratio,
            thumbnailHeight = ratio,

            // 可能有pedding, ready, uploading, confirm, done.
            state = 'pedding',

            // 所有文件的进度信息，key为file id
            percentages = {},

            // WebUploader实例
           // wuploader;

        /*if (!WebUploader.Uploader.support()) {
            //alert('Web Uploader 不支持您的浏览器！如果你使用的是IE浏览器，请尝试升级 flash 播放器');
            layer.msg('Web Uploader 不支持您的浏览器！如果你使用的是IE浏览器，请尝试升级 flash 播放器', { icon: 2 });
            throw new Error('WebUploader does not support the browser you are using.');
        }*/

        // 实例化
        wuploader = WebUploader.create({
            pick : {
                id : filePickerId,
                label : '点击选择图片'
            },
            dnd : webUploaderId + ' .queueList',
            paste : window.document.body,

            accept : {
                title : 'Images',
                extensions : 'gif,jpg,jpeg,bmp,png',
                mimeTypes : 'image/gif,image/jpg,image/jpeg,image/bmp,image/png'
            },

            // swf文件路径
            swf : '/js/plugins/webuploader/Uploader.swf',

            disableGlobalDnd : true,

            chunked : true,
            server : uploadUrl,
            fileNumLimit : 2
        //fileSizeLimit: 5 * 1024 * 1024,    // 5 M
        //fileSingleSizeLimit: 1 * 1024 * 1024    // 1 M
        });

        // 添加“添加文件”的按钮，
        wuploader.addButton({
            id : fileAddId,
            label : '继续添加'
        });

        // 当有文件添加进来时执行，负责view的创建
        function addFile(file) {
            var $li = $('<li id="' + file.id + '">' +
                    // '<p class="title">' + file.name + '</p>' +
                    '<p class="imgWrap"></p>' +
                    '<p class="progress"><span></span></p>' +
                    '</li>'),

                $btns = $('<div class="file-panel">' +
                    '<span class="cancel">删除</span></div>').appendTo($li),
                $prgress = $li.find('p.progress span'),
                $wrap = $li.find('p.imgWrap'),
                $info = $('<p class="error"></p>'),

                showError = function(code) {
                    switch (code) {
                    case 'exceed_size':
                        text = '文件大小超出';
                        break;

                    case 'interrupt':
                        text = '上传暂停';
                        break;

                    default:
                        text = '上传失败，请重试';
                        break;
                    }

                    $info.text(text).appendTo($li);
                };

            if (file.getStatus() === 'invalid') {
                showError(file.statusText);
            } else {
                // @todo lazyload
                $wrap.text('预览中');
                wuploader.makeThumb(file, function(error, src) {
                    if (error) {
                        $wrap.text('不能预览');
                        return;
                    }

                    //var img = $('<img src="'+src+'">');

                    // 使用data-fancybox-href，解决IE中图片显示的问题。
                    // TODO data-fancybox-group怎么确保唯一性？
                    var img = $('<a class="fancybox" data-fancybox-group="gallery' + webUploaderId + '" data-fancybox-href="' + src + '"><img src="' + src + '"></a>');

                    $wrap.empty().append(img);
                }, thumbnailWidth, thumbnailHeight);

                percentages[file.id] = [ file.size, 0 ];
            }

            file.on('statuschange', function(cur, prev) {
                if (prev === 'progress') {
                    $prgress.hide().width(0);
                } else if (prev === 'queued') {
                    $li.off('mouseenter mouseleave');
                    $btns.remove();
                }

                // 成功
                if (cur === 'error' || cur === 'invalid') {
                    console.log(file.statusText);
                    showError(file.statusText);
                    percentages[file.id][1] = 1;
                } else if (cur === 'interrupt') {
                    showError('interrupt');
                } else if (cur === 'queued') {
                    percentages[file.id][1] = 0;
                } else if (cur === 'progress') {
                    $info.remove();
                    $prgress.css('display', 'block');
                } else if (cur === 'complete') {
                    $li.append('<span class="success"></span>');
                }

                $li.removeClass('state-' + prev).addClass('state-' + cur);
            });

            $li.on('mouseenter', function() {
                $btns.stop().animate({
                    height : 30
                });
            });

            $li.on('mouseleave', function() {
                $btns.stop().animate({
                    height : 0
                });
            });

            $btns.on('click', 'span', function() {
                var index = $(this).index(),
                    deg;

                switch (index) {
                case 0:
                    wuploader.removeFile(file);
                    return;
                }

            });

            $li.appendTo($queue);
        }

        // 负责view的销毁
        function doRemoveFile(file) {
            delete percentages[file.id];
            // 不处理“进度”的更新。让调用方自己负责更新。   by tanzx 2017-08-01
            //updateTotalProgress();

            var $li = $('#' + file.id);
            // 当文件显示出来时，才做移除。
            if ($li) {
                $li.off().find('.file-panel').off().end().remove();
            }

        }

        function updateTotalProgress() {
            var loaded = 0,
                total = 0,
                spans = $progress.children(),
                percent;

            $.each(percentages, function(k, v) {
                total += v[0];
                loaded += v[0] * v[1];
            });

            percent = total ? loaded / total : 0;

            spans.eq(0).text(Math.round(percent * 100) + '%');
            spans.eq(1).css('width', Math.round(percent * 100) + '%');
            updateStatus();
        }

        function updateStatus() {
            var text = '',
                stats;

            if (state === 'ready') {
                text = '选中' + fileCount + '张图片，共' +
                    WebUploader.formatSize(fileSize) + '。';
            } else if (state === 'confirm') {
                stats = wuploader.getStats();
                if (stats.uploadFailNum) {
                    text = '已成功上传' + stats.successNum + '张照片至爱燕子相册，' +
                        stats.uploadFailNum + '张照片上传失败，<a class="retry" href="#">重新上传</a>失败图片或<a class="ignore" href="#">忽略</a>'
                }

            } else {
                stats = wuploader.getStats();
                text = '共' + fileCount + '张（' +
                    WebUploader.formatSize(fileSize) +
                    '），已上传' + stats.successNum + '张';

                if (stats.uploadFailNum) {
                    text += '，失败' + stats.uploadFailNum + '张';
                }
            }

            $info.html(text);
        }

        function setState(val) {
            var file,
                stats;

            if (val === state) {
                return;
            }

            $upload && $upload.removeClass('state-' + state);
            $upload && $upload.addClass('state-' + val);
            state = val;
            switch (state) {
            case 'pedding':
                $placeHolder.removeClass('element-invisible');
                $queue.parent().removeClass('filled');
                $queue.hide();
                $statusBar.addClass('element-invisible');
                wuploader.refresh();
                break;

            case 'ready':
                $placeHolder.addClass('element-invisible');
                $(fileAddId).removeClass('element-invisible');
                // 修改上传按钮为可用。   by tanzx 2017-08-01
                $upload && $upload.removeClass('disabled');
                $queue.parent().addClass('filled');
                $queue.show();
                $statusBar.removeClass('element-invisible');
                wuploader.refresh();
                break;

            case 'uploading':
                $(fileAddId).addClass('element-invisible');
                $progress.show();
                $upload && $upload.text('暂停上传');
                break;

            case 'paused':
                $progress.show();
                $upload && $upload.text('继续上传');
                break;

            case 'confirm':
                $progress.hide();
                $upload && $upload.text('开始上传').addClass('disabled');

                stats = wuploader.getStats();
                if (stats.successNum && !stats.uploadFailNum) {
                    setState('finish');
                    return;
                }
                break;
            case 'finish':
                stats = wuploader.getStats();
                if (stats.successNum) {
                    //alert('上传成功');
                    layer.msg('上传成功', { icon: 1, offset: 't' });
                } else {
                    // 没有成功的图片，重设
                    state = 'done';
                    location.reload();
                }
                break;
            }

            updateStatus();
        }

        wuploader.onUploadProgress = function(file, percentage) {
            var $li = $('#' + file.id),
                $percent = $li.find('.progress span');

            $percent.css('width', percentage * 100 + '%');
            percentages[file.id][1] = percentage;
            updateTotalProgress();
        };

        wuploader.onFileQueued = function(file) {
            fileCount++;
            fileSize += file.size;

            if (fileCount === 1) {
                $placeHolder.addClass('element-invisible');
                $statusBar.show();
            }

            addFile(file);
            // 不需要每次添加文件，都调用setState('ready')。by tanzx 2017-08-01
            setState('ready');
            updateTotalProgress();
        };

        wuploader.onFileDequeued = function(file) {
            fileCount--;
            fileSize -= file.size;

            if (!fileCount) {
                setState('pedding');
            }

            doRemoveFile(file);
            updateTotalProgress();

        };

        // 添加Reset监听。by tanzx 2017-08-01
        // TODO reset不知道有没有问题。是否选择用destroy？
        wuploader.onReset = function() {
            fileCount = 0;
            fileSize = 0;

            setState('pedding');

            // 移除页面上的图片。
            $.each(wuploader.getFiles(), function(index, value) {
                doRemoveFile(value);
            });
            updateTotalProgress();

        };

        wuploader.on('all', function(type) {
            var stats;
            switch (type) {
            case 'uploadFinished':
                setState('confirm');
                break;

            case 'startUpload':
                setState('uploading');
                break;

            case 'stopUpload':
                setState('paused');
                break;

            }
        });

        wuploader.onError = function(code) {
            //alert('Error: ' + code);
            var text = '';
            if (code == 'F_DUPLICATE') {
                text = '文件重复！';
            } else {
                text = 'Error: ' + code;
            }
            layer.msg(text, { icon: 2, offset: 't' });
        };

        $upload && $upload.on('click', function() {
            if ($(this).hasClass('disabled')) {
                return false;
            }

            if (state === 'ready') {
                wuploader.upload();
            } else if (state === 'paused') {
                wuploader.upload();
            } else if (state === 'uploading') {
                wuploader.stop();
            }
        });

        $info.on('click', '.retry', function() {
            wuploader.retry();
        });

        $info.on('click', '.ignore', function() {
            //alert('todo');
            //layer.msg('todo', { icon: 3, offset: 't' });
            //执行忽略动作，重置
            wuploader.reset();
        });

        $upload && $upload.addClass('state-' + state);
        updateTotalProgress();

        // WebUploader实例
        return wuploader;
    } // end initWebUploader

    window.CommonWebUploader = this;
})(window);







/* 
 * 可编辑的相册
 * 
 */
( function( $ ) {
    
    var EditableGallery = function () {
    }
    
    EditableGallery.prototype.addDeletedUrl = function (deletedUrl) {
        if (!this.deletedUrls) {
            this.deletedUrls = [];
        }
        this.deletedUrls.push(deletedUrl);
    }
    
    EditableGallery.prototype.getDeletedUrls = function () {
        return this.deletedUrls;
    }
    
    EditableGallery.prototype.clearDeletedUrls = function () {
        this.deletedUrls = [];
    }
    
    $.fn.extend({
        editableGallery: function( option ) {
            var defaults = {
                urls : [],
                canDelete : false,
                wuploader :"",
                urlArray:[],
                a:'#uploader',
                p:"#filePicker",
                o:"#filePicker2",
                u:"uploadFileToFast",
                drawcontent:"#moduleGallery",
                imagedata:""
            };
            
            var plugin = this;
            
            var value,
                args = Array.prototype.slice.call(arguments, 1);
            
            // 样式可以挂到“上传”那边。
            function makeGallery($wrap, urls, canDelete,wuploader,urlArray,a,p,o,u,drawcontent,imagedata) {
                var data = $wrap.data('editableGallery');
                data['clearDeletedUrls'].apply(data);
                var $fileList = $('<ul class="filelist"></ul>');
                $wrap.empty().append($fileList);
                $.each(urls, function(index, element) {
                    // fancybox放大图片。data-fancybox-group设置为一个独特的值，确保“放大后切换图片时只显示这一组图片”。
                    var $li = $('<li id="' + index + '">' +
                        '<p class="imgWrap"><a class="fancybox" data-fancybox-group="gallery' + $wrap.attr("id")
                        + '" href="' + element + '"><img src="' + element + '"></a></p>' +
                        '</li>');
                    
                    if (canDelete) {
                        var $btns = $('<div class="file-panel">' +
                            '<span class="cancel">删除</span>' +
                            '</div>').appendTo( $li );
                        $li.on( 'mouseenter', function() {
                            $btns.stop().animate({height: 30});             
                        });

                        $li.on( 'mouseleave', function() {
                            $btns.stop().animate({height: 0});
                        });
                        $btns.on( 'click', 'span', function() {
                            var index = $(this).index();

                            switch ( index ) {
                                case 0:
                                	{
                                	
                                	$(a).show();
                                    data['addDeletedUrl'].apply(data, [element]);
                                    $li.off().find('.file-panel').off().end().remove();
                               	 if(urlArray.remove([element])){
                               		 var newLimit = ++wuploader.options.fileNumLimit;
                               		   wuploader.reset();
                               		   wuploader.destroy();
                               		   $(imagedata).val("");
                               		   var w;
                               		 wuploader  = initWebUploaderUI(a,p,o,u,newLimit,w,urlArray,drawcontent,imagedata);
                                	}
                                    return;

                                	}
                            }

                        });
                    }
                    
                    $li.appendTo($fileList);
                });
            }
            
            plugin.each( function() {
                var $this = $( this ),
                    data = $this.data('editableGallery'),
                    options =  $.extend(defaults, typeof option === 'object' && option);
                if ( $this ) {
                    if (typeof option === 'string') {
                        if (!data) {
                            return;
                        }
                        
                        value = data[option].apply(data, args);
                    } else {
                        if (!data) {
                            $this.data('editableGallery', (data = new EditableGallery()));
                        }
                        makeGallery($this, options.urls, options.canDelete,options.wuploader,options.urlArray,options.a,options.p,options.o,options.u,options.drawcontent,options.imagedata);
                    }
                }
            });
            
            return typeof value === 'undefined' ? plugin : value;
            
        } // end editableGallery
    });
}( jQuery ));


//初始化上传插件
function initWebUploaderUI(content,filePicker,filePicker2,url,limit,wuploader,urlArray,drawcontent,imgdata){
	var draw = '#moduleGallery';
	if(drawcontent!=""&&drawcontent!=null&&typeof(drawcontent)!='undefined'){
		draw=drawcontent;
	}
	$(content).remove();
  var str = '  <div id="'+content.substring(1)+'" class="commonWebUploader">   '+           
	  ' <div class="queueList">'+
	  ' <div id="dndArea" class="placeholder">'+
	  '   <div id="'+filePicker.substring(1)+'"></div>'+
	  '   <p>或将照片拖到这里，单次最多可选1张</p>'+
	  '  <p style="font-size: 12px;margin-top: 2px;">提示：请上传3M以下，格式为jpg、png、bmp格式图片，以保证获得最佳效果</p>'+
	  '   </div>'+
	  ' </div>'+
	  ' <div class="statusBar" style="display:none;">'+
	  '  <div class="progress">'+
	  '   <span class="text">0%</span> <span class="percentage"></span>'+
	  ' </div>'+
	  '  <div class="info"></div>'+
	  ' <div class="btns">'+
	  '     <div id="'+filePicker2.substring(1)+'" class="addFileBtn"></div>'+
	  '    <div class="uploadBtn">开始上传</div>'+
	  '  </div>'+
	  ' </div>'+
	  ' </div> ';
  $(draw).after(str);
  if(urlArray.length>=limit){
	  $(content).hide();
  }
      // WebUploader实例
      wuploader = CommonWebUploader.initWebUploader(content,filePicker,filePicker2,url,wuploader);
      wuploader.options.fileNumLimit = limit;
      $(draw).editableGallery({

	         //此处可根据自己的需要进行修改参数，我这里第一个参数：一条数据的ID，第二个参数：这条数据的类型（不需要，可不要），第三个参数：这条数据对应的多张图片的路径集合
	        urls: handleFileUrl("", 2, urlArray),    //2表示模块:文件类型    
	        canDelete: true,        //这个参数定义，鼠标移动到图片上时，显示删除按钮 （查看时，不需要编辑图片，可不要这个属性）
	        wuploader:wuploader,
	        urlArray:urlArray,
	        a:content,
   	        p:filePicker,
   	        o:filePicker2,
   	        u:url,
   	     drawcontent:drawcontent,
   	     imagedata:imgdata
	        });
	
      // 所有文件上传结束时
      wuploader.on( 'uploadFinished', function() {
          var stats = wuploader.getStats();
          // 全部上传成功
          if (!stats.uploadFailNum) {
         	$(content).hide();
         	$(imgdata).val(urlArray);
      		   
      		 wuploader  = initWebUploaderUI(content,filePicker,filePicker2,url,--limit,wuploader,urlArray,drawcontent,imgdata);
             $(draw).editableGallery({

       	         //此处可根据自己的需要进行修改参数，我这里第一个参数：一条数据的ID，第二个参数：这条数据的类型（不需要，可不要），第三个参数：这条数据对应的多张图片的路径集合
       	        urls: handleFileUrl("", 2, urlArray),    //2表示模块:文件类型    
       	        canDelete: true,        //这个参数定义，鼠标移动到图片上时，显示删除按钮 （查看时，不需要编辑图片，可不要这个属性）
       	        wuploader:wuploader,
       	        urlArray:urlArray,
       	        a:content,
       	        p:filePicker,
       	        o:filePicker2,
       	        u:url,
       	        drawcontent:drawcontent,
       	        imagedata:imgdata
       	        });

          }
      });
      wuploader.on('uploadSuccess', function( file,response ) {
    	  urlArray.push(response._raw);
   	});
      return wuploader;
}

/**
 * 操作数组删除 fwz
 */
Array.prototype.indexOf = function(val) { 
	for (var i = 0; i < this.length; i++) { 
	if (this[i] == val) return i; 
	} 
	return -1; 
	};
	Array.prototype.remove = function(val) { 
		var index = this.indexOf(val); 
		if (index > -1) { 
		this.splice(index, 1);
		return true;
		}
		return false;
		};